/* Implementation of Modula-2 MATHS function ARCTANH for 64-bit reals.

   Copyright (C) 1993, Rowley Associates
                       32 Rowley
                       Cam
                       Dursley
                       Glos. GL11 5NT
                       England.

   RcsId: $Id: m2_atnhd.c,v 1.1 93/01/25 20:50:54 paul Rel $

*/

#include <math.h>
#include "m2rtl.h"

unsigned M2RTL_ARCTANHD(r, x)
LONGREAL *r, *x;
{
    *r = 0.5 * (log((1.0 + *x) / (1.0 - *x)));
}
