/* Implementation of dynamic range constructor "{a..b}" for large sets.

   Copyright (C) 1992, Rowley Associates
                       32 Rowley
                       Cam
                       Dursley
                       Glos. GL11 5NT
                       England.

   RcsId: $Id: m2_sdr.c,v 1.1 92/07/28 18:25:49 paul Rel $

*/

#include "m2rtl.h"

void M2RTL_SDR(min, max, set)
unsigned min, max;
SET *set;
{
    int bit, val;

    set += min >> 3;
    bit = 1 << (min & 7);
    val = *set;

    while ((int)min++ <= (int)max)
    {
        val |= bit;
        if ((bit <<= 1) == 0x100)
        {
            *set++ = val; bit = 1; val = *set;
        }
    }

    /* clean-up cached value */
    *set = val;
}


