/* Implementation of Modula-2 MATHS function ARCTANH for 32-bit reals.

   Copyright (C) 1993, Rowley Associates
                       32 Rowley
                       Cam
                       Dursley
                       Glos. GL11 5NT
                       England.

   RcsId: $Id: m2_atnhs.c,v 1.1 93/01/25 20:51:01 paul Rel $

*/

#include <math.h>
#include "m2rtl.h"

unsigned M2RTL_ARCTANHS(i)
unsigned i;
{
    cast c;

    c.i = i;
    c.f = 0.5 * (log((1.0 + c.f) / (1.0 - c.f)));
    return c.i;
}
