/* Copyright (C) 1989, Rowley Associates
                       32 Rowley
                       Cam
                       Dursley
                       Glos. GL11 5NT
                       England.

   RcsId: $Id: m2rtl.h,v 1.2 93/01/21 21:53:19 paul Rel $

*/

#define STDERR    2

#define M2_CASE_ERROR      1
#define M2_IEEE_OVERFLOW   2
#define M2_RETURN_ERROR    3
#define M2_STACK_OVERFLOW  4
#define M2_NIL_DEREFERENCE 5
#define M2_RANGE_ERROR     6
#define M2_NO_MEMORY       7
#define M2_BAD_DISPOSE     8
#define M2_PROCESS_TERM    9
#define M2_DEADLOCK        10

/* Dynamic array descriptor. */
typedef struct {void *adr; int high;} dynarr;

#ifndef _IMST2
/* cast from REAL32 to INT32 */
typedef double LONGREAL;
typedef float REAL;
typedef struct { REAL re, im; } COMPLEX;
typedef struct { LONGREAL re, im; } LONGCOMPLEX;
typedef union cast {unsigned i; REAL f;} cast;
#endif
typedef char SET;
#ifdef __STDC__
/* use underlines because some Helios include files define TRUE and FALSE */
typedef enum {_FALSE, _TRUE} BOOLEAN;
#else
typedef int BOOLEAN;
#define _FALSE 0
#define _TRUE  1
#endif

void M2RTL_HALT(int code);

