IMPLEMENTATION MODULE RealInOut;
  (* Copyright (C) 1989, Rowley Associates
                         32 Rowley
                         Cam
                         Dursley
                         Glos. GL11 5NT
                         England.

     RcsId: $Id: realinou.mod,v 1.1 90/12/10 13:18:46 paul Rel $

  *)

  FROM RealConversions IMPORT
    ConvertRealToStr, ConvertStrToReal;
  IMPORT
    InOut;

  PROCEDURE ReadReal(VAR r: REAL);
    VAR lr: LONGREAL;
  BEGIN
    ReadLongReal(lr);
    IF Done THEN
      Done := lr <= MAX(REAL);
      IF Done THEN r := SHORT(lr) END
    END
  END ReadReal;

  PROCEDURE WriteReal(r: REAL; len: CARDINAL);
  BEGIN
    WriteLongReal(LONG(r), len)
  END WriteReal;

  PROCEDURE ReadLongReal(VAR r: LONGREAL);
    VAR str: ARRAY [0..79] OF CHAR;
  BEGIN
    InOut.ReadString(str);
    Done := InOut.Done;
    IF Done THEN
      ConvertStrToReal(r, str, Done)
    END
  END ReadLongReal;

  PROCEDURE WriteLongReal(r: LONGREAL; len: CARDINAL);
    VAR str: ARRAY [0..79] OF CHAR;
  BEGIN
    ConvertRealToStr(r, str, len, Done);
    IF Done THEN
      InOut.WriteString(str);
      Done := InOut.Done
    END
  END WriteLongReal;

END RealInOut.
